#include "StdAfx.h"
#include "UpdaterApplication.h"
#include "PatchNaverTalk.h"

namespace tipupdater
{

BOOL UpdaterApplication::PreMessageLoop()
{
	Set_CommCast_to_NaverTalk_Restarted( IsForceRestart() );

	if (FALSE == IsValidRun())
		return FALSE;	

	// Document Open
	TipCommand* command = dynamic_cast<TipCommand*>(TipCommandFactory::get_instance()->CreateAction(_T("OpenDocumentCommand")));
	if (command->Execute() == FALSE)
	{
		ATLTRACE(_T("OpenDocumentCommand Fail...\n"));
		return FALSE;
	}

	CheckRunEnvironmentCommand* environCommand = dynamic_cast<CheckRunEnvironmentCommand*>(TipCommandFactory::get_instance()->CreateAction(_T("CheckRunEnvironmentCommand")));
	environCommand->SetApplication(this);
	if (environCommand->Execute() == FALSE)
	{
		return FALSE;
	}

	if (IsSilentRun())
	{
		command = dynamic_cast<TipCommand*>(TipCommandFactory::get_instance()->CreateAction(_T("ExcuteSilent")));
		if (command)				
			command->Execute();
	}

	return TRUE;
}

BOOL UpdaterApplication::PostMessageLoop()
{	
	if ( IsRestartUpdaterOnExit() )
	{
		ForceRestartToolsUpdater();
	}

	return TRUE;
}

};